/*
  Created by guanghui on 4/8/14.
http://www.idevgames.com/forums/thread-3010.html
*/

varying vec2 v_texCoord;
varying vec4 v_fragmentColor;

uniform vec3 u_outlineColor;
uniform float u_threshold;
uniform float u_radius;
uniform float u_offset;
uniform float u_margin;
uniform float u_alpha;

void main()
{
    float radius = u_radius;

    float kkkkkk = 0.0;
    vec4 accum = vec4(0.0);
    vec4 normal = vec4(0.0);
    vec4 glow = vec4(0.0);
    
    normal = texture2D(CC_Texture0, vec2(v_texCoord.x, v_texCoord.y));
    
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x - radius, v_texCoord.y - radius));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x + radius, v_texCoord.y - radius));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x + radius, v_texCoord.y + radius));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x - radius, v_texCoord.y + radius));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x - radius, v_texCoord.y + 0.0));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x + radius, v_texCoord.y + 0.0));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x + 0.0, v_texCoord.y + radius));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x + 0.0, v_texCoord.y - radius));

    accum += texture2D(CC_Texture0, vec2(v_texCoord.x - 0.5*radius, v_texCoord.y - radius));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x + 0.5*radius, v_texCoord.y - radius));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x + 0.5*radius, v_texCoord.y + radius));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x - 0.5*radius, v_texCoord.y + radius));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x - 0.5*radius, v_texCoord.y + 0.0));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x + 0.5*radius, v_texCoord.y + 0.0));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x + 0.0, v_texCoord.y + radius));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x + 0.0, v_texCoord.y - radius));

    accum += texture2D(CC_Texture0, vec2(v_texCoord.x - radius, v_texCoord.y - 0.5*radius));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x + radius, v_texCoord.y - 0.5*radius));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x + radius, v_texCoord.y + 0.5*radius));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x - radius, v_texCoord.y + 0.5*radius));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x - radius, v_texCoord.y + 0.0));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x + radius, v_texCoord.y + 0.0));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x + 0.0, v_texCoord.y + 0.5*radius));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x + 0.0, v_texCoord.y - 0.5*radius));
    
    accum *= u_threshold;
    accum.rgb =  u_outlineColor * accum.a;

    accum.a = 0.0f;
    float k = 0.0f;
    for (k = 0.0f; k < u_margin; k += u_offset)
    {
    glow += texture2D(CC_Texture0, vec2(v_texCoord.x - k, v_texCoord.y - k));
    glow += texture2D(CC_Texture0, vec2(v_texCoord.x + k, v_texCoord.y - k));
    glow += texture2D(CC_Texture0, vec2(v_texCoord.x + k, v_texCoord.y + k));
    glow += texture2D(CC_Texture0, vec2(v_texCoord.x - k, v_texCoord.y + k));
    glow += texture2D(CC_Texture0, vec2(v_texCoord.x - k, v_texCoord.y + 0.0));
    glow += texture2D(CC_Texture0, vec2(v_texCoord.x + k, v_texCoord.y + 0.0));
    glow += texture2D(CC_Texture0, vec2(v_texCoord.x + 0.0, v_texCoord.y + k));
    glow += texture2D(CC_Texture0, vec2(v_texCoord.x + 0.0, v_texCoord.y - k));
    }
	accum.a = glow.a / (u_margin/u_offset) / 8.0f;

    normal = accum;//( accum * (1.0 - normal.a)) + (normal * normal.a);
    gl_FragColor = normal;//v_fragmentColor * normal;
}

