#ifdef GL_ES
precision mediump float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

void main(void)
{
	vec4 c = texture2D(CC_Texture0, v_texCoord);
	float max = c.r;
	float min = c.r;
	if(max < c.g)
	{
		max = c.g;
		if(max < c.b)
		{
			max = c.b;
		}
		else
		{
			if(min > c.b)
			{
				min = c.b;
			}
		}
	}
	else
	{
		min = c.g;
		if(min > c.b)
		{
			min = c.b;
		}
		else
		{
			if(max < c.b)
			{
				max = c.b;
			}
		}
	}

    //gl_FragColor = v_fragmentColor * texture2D(CC_Texture0, v_texCoord);

	//gl_FragColor.xyz = vec3(0.33333*c.r + 0.33333*c.g + 0.33334*c.b);
	//gl_FragColor.xyz = vec3(0.5 * (max + min));

    c.xyz = vec3(0.5 * (max + min));
    gl_FragColor = v_fragmentColor * c;
}